;******************************************************************************
;    Filename: LCD_SyncEeprom.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC,LCD_Text.asm           *
;                                                                             *
;******************************************************************************
	#include Define.h	;     
;*******************************
;    -   
;*******************************
 #ifdef	EPROM_Present
;  2  16/01/2019:
;   " ",        
;   .         
;   .
;    -       N    .
;            
;    ,   .
;   -      .
;    -    ,        .
; /   -           . 
;   -       -       .
; 

;******************************************************************************
;$ #ifdef	EPROM_Present
EEPROM_data code_pack 0xf00000 ;   
EPROM_DatB	;    
  #include Proj_Dir\EPROM\EPROM_Data.inc	;    
EPROM_DatE	;    
 ;#endif
;******************************************************************************

	global	EPROM_Sync,EPROM_Read;,EPROM_Table;,ParametrStor

EPROM_Sync	code
	Extern	InitAll, MotorFault	;
	;      NOP
	goto	InitAll	;       - 
EPROM_Table
 #include Proj_Dir\EPROM\EPROM_RegsAdr.inc	;      
EPROM_Sync
;    
; (EPROM_Sync-EPROM_Table)/2;   
; EPROM_DatE-EPROM_DatB	;    
; ParametrCmn	d'15';      
; ParamBlockNum d'16';    
; error "Access RAM exeeds 96 byte"
; messg "Access RAM lenght " \x EndOfAccess

;; *******  	
;	movlw (EPROM_Sync-EPROM_Table)/2
;	movlw (EPROM_DatE-EPROM_DatB)
;	movlw ParametrCmn+ParamBlockLen*ParamBlockNum
;	movlw (EPROM_DatE-EPROM_DatB-ParametrCmn)/ParamBlockNum
;	movlw (EPROM_DatE-EPROM_DatB-ParametrCmn)/ParamBlockLen
;;   
 #if ((EPROM_Sync-EPROM_Table)/2) != (ParametrCmn+ParamBlockLen) ;   
  error "Size defined RAM Block NOT equal summ of ParametrCmn + ParamBlockLen" 
 #endif
 #if (EPROM_DatE-EPROM_DatB) != (ParametrCmn+ParamBlockLen*ParamBlockNum) ;    
  messg "Size defined EPROM Block NOT equal summ of ParametrCmn + ParamBlockLen*ParamBlockNum" 
 #endif
 
	EPROM_Page ; BSR for EPROM Task
 	BTFSC EECON1, WR ; Wait for write to complete
 return	;    -  

	BCF EECON1, WREN,ACCESS	; Disable writes - all time
	BCF PIR2, EEIF,ACCESS 	; Clear interrupt flag

	btfsc	LCD_Flg1,1,ACCESS	;   ?
		bra	Ee_Done1			;  
;MotorNumberCompare;          
;       

 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	clrf	EEADR,ACCESS	;  
	BSF EECON1,RD,ACCESS		 ; EEPROM Read =  EEDATA
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
	movff   WREG,PCPWM_MotorNum ;    

	cpfseq	EEDATA,ACCESS;      
		bra	MotorNumChange	;    -       
;    -    .

	clrf CountSyn,BANKED;           
;   
	incf	CountSyn,F,BANKED		;    -   
;     +2 =   
	movlf	 low(EPROM_Table+2),TblPtrBuf+0,BANKED;TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table+2),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    
;	clrf	TBLPTRU,ACCESS		;<64 kB     
	bsf		LCD_Flg1,1,ACCESS	;    
Ee_Done1	;        

	BCF EECON1, CFGS,ACCESS		; Point to memory
	clrf	TBLPTRU,ACCESS		;<64 kB     
  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

	btfsc	LCD_Flg1,5,ACCESS	;     ?
		bra	Ee_Done2			;    

	MOVFF CountSyn,EEADR ; Data Memory Address to read
;	MOVFF EE_AdrTemp,EEADR ; Data Memory Address to read
	movlw	ParametrCmn-1	;    

;;    
 rcall	EpromCompareWrite	;     
;	movwf	EE_CountTemp,BANKED;   
; bcf	INTCON,GIEL,ACCESS	;    
;;    EECON1         
;	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
;	BSF EECON1, RD,ACCESS		 ; EEPROM Read =  EEDATA
;
;	movf	INDF0,W,ACCESS	;     
;
;	cpfseq	EEDATA,ACCESS		;     
;		rcall	Ee_Write		;    
;
;	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
; bsf	INTCON,GIEL,ACCESS	;    
;	incf	CountSyn,F,BANKED		;   
;
;	movf	EE_CountTemp,W,BANKED	;    
;
;	cpfsgt	CountSyn,BANKED		;    
; return	; /   1       
;;     
 	bsf		LCD_Flg1,5,ACCESS	;     
 return	; /   1     
		;  ;   	

Ee_Done2	;      
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
;	movff   WREG,PCPWM_MotorNum ;   

	mullw	ParamBlockLen; d'13';    
	movf	PRODL,W,ACCESS	;   
;	decf	PRODL,W,ACCESS	;  -1 (  ) 
	addwf	CountSyn,W,BANKED	;    
	movwf	EEADR,ACCESS ;   EPROM
	movlw	ParametrCmn+ParamBlockLen-1	;    

;;    
 rcall	EpromCompareWrite	;     
;	movwf	EE_CountTemp,BANKED;   
;
; bcf	INTCON,GIEL,ACCESS	;    
;;    EECON1         
;
;	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
;	BSF EECON1, RD,ACCESS		 ; EEPROM Read =  EEDATA
;	movf	INDF0,W,ACCESS	;     
;	cpfseq	EEDATA,ACCESS		;     
;		rcall	Ee_Write		;    
;	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
; bsf	INTCON,GIEL,ACCESS	;    
;	incf	CountSyn,F,BANKED		;   
;	movf	EE_CountTemp,W,BANKED	;    
;;	movlw	ParametrCmn+ParamBlockLen-1	;    
;;	cpfslt	CountSyn,BANKED		;    
;	cpfsgt	CountSyn,BANKED		;    
; return	; /   1       
;;     
;EndSyncEprom
	bcf		LCD_Flg1,0,ACCESS	;  
	bcf		LCD_Flg1,1,ACCESS	;    
	bcf		LCD_Flg1,5,ACCESS	;     
 return

EpromCompareWrite	;     
;            
;    EE_CountTemp;F,BANKED;   
;    
	movwf	EE_CountTemp,BANKED;   
 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	BSF EECON1, RD,ACCESS		 ; EEPROM Read =  EEDATA
	movf	INDF0,W,ACCESS	;     
	cpfseq	EEDATA,ACCESS		;     
		rcall	Ee_Write		;    
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    
	incf	CountSyn,F,BANKED		;   
	movf	EE_CountTemp,W,BANKED;   
	cpfsgt	CountSyn,BANKED		;    
 pop;    ;	return	; /   1       
;     
 return

Ee_Write;    
	movwf	EEDATA,ACCESS		;          
	incf	EpromWriteCount,F,ACCESS	;
	;BCF EECON1, EEPGD ; Point to DATA memory
	BSF EECON1, WREN,ACCESS; Enable writes
	BCF INTCON, GIE,ACCESS; Disable Interrupts
		MOVLW 0x55 ;
		MOVWF EECON2,ACCESS ; Write 55h
		MOVLW 0xAA ;
		MOVWF EECON2,ACCESS ; Write AAh
	BSF EECON1, WR,ACCESS ; Set WR bit to begin write
	BCF EECON1, WREN,ACCESS ; Disable writes - not affect for begin write
	BSF INTCON, GIE,ACCESS ; Enable Interrupts
 return
MotorNumChange	;    -       
;     -  ,  -  
	movlw	0xEE;    
 call	MotorFault	;       
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
;	movff   WREG,PCPWM_MotorNum ;   
 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	clrf	EEADR,ACCESS	;  =   
 rcall	Ee_Write		;    
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

 	BTFSC EECON1, WR ; Wait for write to complete
	bra $-2;      
;		reset

EPROM_Read	;          -  19/01/2019
;   -     , 2  .
;            .

;       
	EPROM_Page ; BSR for EPROM Task
	clrf CountSyn,BANKED;      
	BCF EECON1, CFGS,ACCESS ; Point to memory	

;	movlf	low(EPROM_Table),TblPtrBuf,BANKED;TBLPTRL,ACCESS;   
;	movlf	high(EPROM_Table),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    

	movlf	low(EPROM_Table),TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table),TBLPTRH,ACCESS;    

	clrf	TBLPTRU,ACCESS		;<64 kB 
	
LoopReadEpromCmn
	MOVFF CountSyn,EEADR ; Data Memory Address to read
 rcall	ReadEpromRam;     
;;     
;	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
;	tblrd*+	;    
;	movff	TABLAT,FSR0L	;   
;	tblrd*+	;      
;	movff	TABLAT,FSR0H	;   
;
;	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
;	BSF EECON1, RD,ACCESS ; EEPROM Read
;	nop	; EPROM DATA Valid
;	
;;	movff	EEDATA,INDF0	;      
;	movf	EEDATA,W,ACCESS
;	movwf	INDF0,ACCESS	;      
;
;	incf	CountSyn,F,BANKED		;   
;;     

	movlw	ParametrCmn-1	;    
;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
		bra LoopReadEpromCmn

LoopReadEpromInd
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15

	mullw	ParamBlockLen; d'13';    
	movf	PRODL,W,ACCESS	;   
	addwf	CountSyn,W,BANKED	;    
	movwf	EEADR,ACCESS ;   EPROM
 rcall	ReadEpromRam;     
;;      
;	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
;	tblrd*+	;    
;	movff	TABLAT,FSR0L	;   
;	tblrd*+	;      
;	movff	TABLAT,FSR0H	;   
;
;	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
;	BSF EECON1, RD,ACCESS ; EEPROM Read
;	nop	; EPROM DATA Valid
;	
;;	movff	EEDATA,INDF0	;      
;	movf	EEDATA,W,ACCESS
;	movwf	INDF0,ACCESS	;      
;	incf	CountSyn,F,BANKED		;   
;;     
;
	movlw	ParametrCmn+ParamBlockLen-1	;    
;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
		bra LoopReadEpromInd
			return 
;     
ReadEpromRam
;      
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
	tblrd*+	;    
	movff	TABLAT,FSR0L	;   
	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
	BSF EECON1, RD,ACCESS ; EEPROM Read
	nop	; EPROM DATA Valid
	
;	movff	EEDATA,INDF0	;      
	movf	EEDATA,W,ACCESS
	movwf	INDF0,ACCESS	;      
	incf	CountSyn,F,BANKED		;   
;     
	return	

;*******************************
;    -   
;*******************************
 #endif	;#ifdef	EPROM_Present
;End of program

		END
